# Summary

- [Introduction](./introduction.md)
- [Quickstart](./quickstart.md)
- [Syntax](./syntax/syntax.md)
  - [Objects](./syntax/objects.md)
  - [Property options](./syntax/property_options.md)
  - [Enumerations](./syntax/enums.md)
  - [Descriptions](./syntax/descriptions.md)
  - [Semantics](./syntax/semantics.md)
  - [Preambles](./syntax/preambles.md)
  - [Full example](./syntax/full_example.md)
  - [Best practices](./syntax/best_practices.md)
- [Command Line Interface](./cli/cli.md)
  - [Generation](./cli/code_generation.md)
  - [Pipelines](./cli/pipelines.md)
  - [Validation](./cli/schema_validation.md)
  - [Large Language Models](./cli/llm.md)
- [Export specifications](./exporters/exporters.md)
  - [Programming languages](./exporters/languages.md)
  - [Schema languages](./exporters/schemas.md)
  - [API specifications](./exporters/apis.md)
  - [Documentation](./exporters/documentation.md)
- [Examples](./examples/examples.md)
  - [Hello MD-Models](./examples/hello_md_models.md)
  - [Union types](./examples/union_types.md)
  - [Database models](./examples/database_models.md)
- [FAQ](./faq/faq.md)
